package provider

import scala.concurrent.Future

trait Provider[Key, Entry]:
  def retrieve(key: Key): Future[Entry]
  def retrieveKeys: Future[Set[Key]]

trait ProviderSync[Key, Entry]:
  // Deprecated
  def retrieveSync(key: Key): Option[Entry]

  // Deprecated
  def retrieveKeysSync: Set[Key]
